#pragma once

#include <memory>
#include <QList>
#include "libtokens.h"


namespace lib_syntax {
	class ExprRule;
}

// ﷨ṹ ====================================================================
namespace ast_basic {
	/**
	 * @brief ﷨Ͻڵ/ʽڵ
	 */
	class IExprInstance {
	public:
		/**
		 * @brief ȡʽĽ
		 * @return
		 */
		virtual std::shared_ptr<const lib_syntax::ExprRule> definedRule() const = 0;
		//=====================================================
		/**
		 * ȡ﷨ڵԴļ·.
		 *
		 * \return ļ·
		 */
		virtual QString filePath() const = 0;
		/**
		 * ȡ﷨ڵtoken.
		 *
		 * \return token
		 */
		virtual QList<std::shared_ptr<const lib_token::IToken>> tokens() const = 0;
		/**
		 * Уʽڲtokenʵ.
		 *
		 * \param token_inst ʵ
		 */
		virtual void addToken(std::shared_ptr<const lib_token::IToken> token_inst) = 0;
		//=====================================================
		/**
		 * @brief ӱʽ
		 * @return
		 */
		virtual QList<std::shared_ptr<const IExprInstance>> children() const = 0;
		/**
		 * @brief ӱʽ.
		 *
		 * \param inst ӱʽʵ
		 */
		virtual void addChild(std::shared_ptr<const IExprInstance> inst) = 0;
	};


	// ﷨ ==========================================================================================
	/**
	 * @brief ʽڵ
	 */
	class LIBSYNTAX_EXPORT ExprInstance : public IExprInstance, public std::enable_shared_from_this<ExprInstance> {
	private:
		std::shared_ptr<const lib_syntax::ExprRule> _expr_rule;
		QList<std::shared_ptr<const IExprInstance>> children_store;
		QList<std::shared_ptr<const lib_token::IToken>> tokens_bind;

	public:
		ExprInstance(std::shared_ptr<const lib_syntax::ExprRule> bind);

		// ͨ Expression ̳
		std::shared_ptr<const lib_syntax::ExprRule> definedRule() const override;
		QString filePath() const override;

		QList<std::shared_ptr<const lib_token::IToken>> tokens() const override;
		void addToken(std::shared_ptr<const lib_token::IToken> token_inst) override;

		QList<std::shared_ptr<const IExprInstance>> children() const override;
		void addChild(std::shared_ptr<const IExprInstance> inst) override;
	};

	/**
	* @brief ʽڵ
	*/
	class LIBSYNTAX_EXPORT ExprProgram : public IExprInstance, public std::enable_shared_from_this<ExprProgram> {
	private:
		QList<std::shared_ptr<const IExprInstance>> _children_store;
		QString _program_root;
		
	public:
		ExprProgram(const QString &root);

		// ͨ IExprInstance ̳
		std::shared_ptr<const lib_syntax::ExprRule> definedRule() const override;
		QString filePath() const override;
		QList<std::shared_ptr<const lib_token::IToken>> tokens() const override;
		void addToken(std::shared_ptr<const lib_token::IToken> token_inst) override;
		QList<std::shared_ptr<const IExprInstance>> children() const override;
		void addChild(std::shared_ptr<const IExprInstance> inst) override;
	};
}