#pragma once

#include "libsyntax_global.h"
#include <libwords.h>

namespace ast_basic {
	class IExprInstance;
}

namespace lib_token {

	/**
	 * @brief 쳣
	 */
	class LIBSYNTAX_EXPORT TokenException {
	private:
		QString msg_store;

	public:
		TokenException(const QString& message);
		virtual QString message() const;
	};






	// token Ƴӿ==========================================
	/**
	 * @brief tokenͶ
	 */
	class ITokenDefine {
	public:
		/**
		 * @brief ͱʶ.
		 *
		 * \return
		 */
		virtual int typeMark() const = 0;
		/**
		 * @brief ƹؼ
		 * @return
		 */
		virtual QString regex() const = 0;
	};

	/**
	 * @brief token
	 */
	class IToken : public lib_words::IWordBase, public std::enable_shared_from_this<IToken> {
	public:
		/**
		 * @brief tokenƹ
		 * @return
		 */
		virtual std::shared_ptr<const ITokenDefine> defines() const = 0;
	};


	// չӿ=========================
	/**
	* @brief tokenƶ
	*/
	class ITokenProcess : public ITokenDefine {
	public:
		/**
		 * @brief 
		 * @return
		 */
		virtual QString reviseWords() const = 0;
		/**
		 * @brief ﴦ
		 * @param content 
		 * @return tuple<token/null,remains> 
		 */
		virtual std::tuple<std::shared_ptr<const IToken>, std::shared_ptr<const lib_words::IPrimitiveWord>>
			analysis(std::shared_ptr<const lib_words::IPrimitiveWord> content) const = 0;
	};


	/**
	* @brief Token
	*/
	class IActionToken : public lib_token::IToken {
	public:

		/**
		* @brief һToken
		* @return
		*/
		virtual std::shared_ptr<const IActionToken> prevToken() const = 0;
		/**
		* @brief ʵTokenݵָexpr״̬expr
		* @param expr Ŀʽʵ
		* @return ƺıʽ
		*/
		virtual std::shared_ptr<ast_basic::IExprInstance> makeSure(std::shared_ptr<ast_basic::IExprInstance> expr) = 0;
	};

}