#pragma once

#include "libwords_global.h"
#include <memory>
#include <QtCore/QString>


namespace lib_words {
	/**
	 * @brief Դʵ
	 */
	class IWordBase {
	public:
		/**
		 * @brief Դļ·
		 * @return
		 */
		virtual QString file() const = 0;
		/**
		* @brief ȡλ
		* @return ʼλ
		*/
		virtual uint64_t position() const = 0;
		/**
		 * @brief 
		 * @return
		 */
		virtual QString content() const = 0;
		/**
		 * @brief Դк
		 * @return
		 */
		virtual int row() const = 0;
		/**
		 * @brief Դк
		 * @return
		 */
		virtual int column() const = 0;
	};

	class IPrimitiveWord : public IWordBase {
	public:
		/**
		 * @brief һ.
		 *
		 * \return
		 */
		virtual std::shared_ptr<const IPrimitiveWord> nextWord() const = 0;
	};

	/**
	 * @brief δԭʼ
	 */
	class LIBWORDS_EXPORT WordContent : public IPrimitiveWord {
	private:
		int row_n, col_n;
		uint64_t doc_offset;
		QString text_n, path_p;

	public:
		WordContent(int r, int c, uint64_t pos, const QString& t, const QString& p);

		// WordBase interface
	public:
		virtual QString file() const override;
		virtual uint64_t position() const override;
		virtual QString content() const override;
		virtual int row() const override;
		virtual int column() const override;
		virtual std::shared_ptr<const IPrimitiveWord> nextWord() const override;
	};

	class LIBWORDS_EXPORT WordImpl : public IPrimitiveWord {
	private:
		std::shared_ptr<const IWordBase> content_ptr;
		std::shared_ptr<const IPrimitiveWord> next_ptr;

	public:
		WordImpl(std::shared_ptr<const IWordBase> content, std::shared_ptr<const IPrimitiveWord> next);

		// ͨ IWordBase ̳
		QString file() const override;
		virtual uint64_t position() const override;
		QString content() const override;
		int row() const override;
		int column() const override;
		std::shared_ptr<const IPrimitiveWord> nextWord() const override;
	};


	/**
	 * @brief Դȡ
	 */
	class LIBWORDS_EXPORT WordReader {
	private:
		QList<std::shared_ptr<const IWordBase>> parse_line(uint64_t start_pos, int row, const QString& line_text, const QString& path) const;
		QList<std::shared_ptr<const IWordBase>> extract_primary(const QString& path) const;

	public:
		/**
		* @brief ȡԴеĴ
		*/
		std::shared_ptr<const IPrimitiveWord> wordsFrom(const QString& path) const;
	};



	/**
	 * @brief 쳣
	 */
	class LIBWORDS_EXPORT WordsException {
	private:
		QString msg_store;

	public:
		WordsException(const QString& message);
		virtual QString message() const;
	};
}